CREATE TABLE TEMP_TREE
(
  ARDE_TABLE varchar(100),
  ARDE_CLEP integer NOT NULL,
  ARDE_PARENT integer,
  ARDE_TABLE_PARENT varchar(20),
  ARDE_TABLE_CLEP varchar(20),
  ARDE_TYPE smallint,
  ARDE_SELECTION smallint,
  ARDE_PRIX decimal(12,4),
  ARDE_PRIXFUTUR decimal(12,4),
  ARDE_LIBELLE varchar(360),
  ARDE_LIBCOM varchar(200),
  ARDE_POSITION integer,
  ARDE__COMP varchar(20),
  ARDE_NIVEAU integer,
  PRIMARY KEY (ARDE_CLEP)
);

CREATE GENERATOR TEMP_TREE_POS;
SET GENERATOR TEMP_TREE_POS TO 1;
SET TERM ^ ;



CREATE PROCEDURE FC_ARBRE_BASE_COMPOSE (
    BASE_COMPOSE varchar(20),
    COMPOSANTS smallint )
AS
DECLARE CleTable varchar (20);
DECLARE CleTableLiee varchar (20);
DECLARE CleTableComp varchar (20);
DECLARE CleTable2 varchar (20);
DECLARE CleTable3 varchar (20);
DECLARE Cle integer;
DECLARE CleLiee integer;
DECLARE CleComp integer;
DECLARE Niveau integer;
DECLARE NiveauBranche integer;
DECLARE indice integer;
BEGIN
Niveau=1;
Indice=0;
Cle=1;
--SET GENERATOR TEMP_TREE_POS TO 1;
----------- Insertion de BASE_COMPOSE -------------
INSERT INTO TEMP_TREE (ARDE_Table,
  ARDE_Clep,	
  ARDE_Parent,
  ARDE_Table_parent, -- La cl parent de la table
  ARDE_Table_clep, -- La cl de la table
  ARDE_Type,
  ARDE_Selection,
  ARDE_Prix,
  ARDE_Prixfutur,
  ARDE_Libelle,
  ARDE_Libcom,
  ARDE_Position,
  ARDE__COMP,
  ARDE_Niveau ) SELECT  'BASE_COMPOSE',
	1,
	NULL,
	NULL,
	ARTI_Clep,
	0,
	9, 
	ARTI_Pxactu, 
	ARTI_Pxfutur, 
	ARTI_Libcom,
	ARTI_Libcom,
	-1,
	NULL,
	0
FROM ARTICLE
WHERE  ARTI_Clep= :BASE_COMPOSE
AND ARTI_Compose;

INSERT INTO TEMP_TREE (ARDE_Table,
  ARDE_Clep,	
  ARDE_Parent,
  ARDE_Table_parent, -- La cl parent de la table
  ARDE_Table_clep, -- La cl de la table
  ARDE_Type,
  ARDE_Selection,
  ARDE_Prix,
  ARDE_Prixfutur,
  ARDE_Libelle,
  ARDE_Libcom,
  ARDE_Position,
  ARDE__COMP,
  ARDE_NIVEAU )  SELECT  'ARTC_STRU',
	:NIVEAU*1000+:INDICE+GEN_ID(TEMP_TREE_POS,1),
	1,
	:BASE_COMPOSE,
	STRU_Clep,
	STRU_Type,
	STRU_Selectionne, 
	NULL,
	NULL,
	STRU_Libelle,
	NULL,
	STRU_Position,
	NULL,
	:NIVEAU
	FROM STRUCTURE, ARTICLE_STRUCTURE 
	WHERE ARST__STRU = STRU_Clep 
	AND ARST__ARTI= :BASE_COMPOSE
	ORDER BY STRU_Position,STRU_Libelle;
for SELECT ARDE_Table_clep, ARDE_Clep FROM TEMP_TREE WHERE ARDE_Type=1 AND ARDE_Parent=1 into CleTableLiee, CleLiee do
  Begin
     INSERT INTO TEMP_TREE with recursive temp_tree2 as (SELECT STRU_Clep as indent,:CleTableLiee as tableparent,:NIVEAU +1 as NiveauBranche2,(:NIVEAU +1)*1000+:INDICE+GEN_ID(TEMP_TREE_POS,1) as counter,:CleLiee as parent FROM STRUCTURE,STRUCTURE_LIEE  WHERE STLI__Enfant = STRU_Clep AND STLI__Parent= :CleTableLiee
                                               UNION all SELECT STRU_Clep          ,j.indent                    , NIVEAUBRANCHE2+1           ,( NIVEAUBRANCHE2+1)*1000+:INDICE+GEN_ID(TEMP_TREE_POS,1)    ,j.counter FROM STRUCTURE,STRUCTURE_LIEE JOIN TEMP_TREE2 as j on(STLI__Parent=j.indent) WHERE STLI__Enfant = STRU_Clep) 
            SELECT  'STRUCTURE_LIEE',
            h.counter,
            h.parent,
            tableparent,
            STRU_Clep,
            STRU_Type,
            STRU_Selectionne, 
            NULL,
            NULL,
            STRU_Libelle,
            NULL,
            STRU_Position,
            NULL,
            NiveauBranche2
        FROM STRUCTURE, temp_tree2 as h
        WHERE STRU_Clep= h.indent
        ORDER BY STRU_Position,STRU_Libelle;

        UPDATE TEMP_TREE
            SET ARDE_Prix  = ( SELECT SUM ( COMP_Prixactuel ) FROM STRUCTURE_COMPOSANT, COMPOSANT 
                    WHERE ARDE_Type=3
                    AND ARDE_Parent = :Cle
                    AND ARDE_Table = 'STRUCTURE_LIEE'
                    AND SCOM__STRU = ARDE_Table_clep
                    AND SCOM__COMP = COMP_Clep )
            ,
            ARDE_Prixfutur = ( SELECT SUM ( COMP_Prixfutur ) FROM STRUCTURE_COMPOSANT, COMPOSANT 
                    WHERE ARDE_Type=3
                    AND ARDE_Parent = :Cle
                    AND ARDE_Table = 'STRUCTURE_LIEE'
                    AND SCOM__STRU = ARDE_Table_clep
                    AND SCOM__COMP = COMP_Clep )
                WHERE ARDE_Type=3
                AND ARDE_Parent = :Cle;

          IF (:composants = 1) then
            BEGIN

            FOR SELECT ARDE_Table_clep, ARDE_Clep, ARDE_Niveau FROM TEMP_TREE WHERE ARDE_Type=3 into CleTableComp, CleComp, NiveauBranche do
                Begin
                    INSERT INTO TEMP_TREE
                        SELECT DISTINCT 'STRUCTURE_COMPOSANT',
                        (:NiveauBranche+1)*1000+:INDICE+GEN_ID(TEMP_TREE_POS,1),
                        :CleComp,
                        :CleTableComp,
                        COMP_Clep,
                        STRU_Type,
                        9, 
                        COMP_Prixactuel,
                        COMP_Prixfutur,
                        COMP_Lib,
                        COMP_Libcom,
                        STRU_Position,
                        NULL,
                        :NiveauBranche+1
                    FROM STRUCTURE LEFT OUTER JOIN STRUCTURE_COMPOSANT ON ( SCOM__STRU = STRU_Clep ) LEFT OUTER JOIN COMPOSANT ON ( SCOM__COMP = COMP_Clep )
                    WHERE SCOM__STRU = :CleTableComp
                    ORDER BY STRU_Position, COMP_Lib;
                    suspend;
                End
            END

          IF (:composants = 2) then
            BEGIN
                FOR SELECT SCOM__COMP,SCOM__STRU FROM STRUCTURE_COMPOSANT WHERE SCOM__STRU=:CleTableLiee into CleTable3, CleTable2 do
                    Begin
                        UPDATE TEMP_TREE
                            SET ARDE__COMP = :CleTable3
                            WHERE ARDE_Table_clep = :CleTable2	
                            AND ARDE_Type = 2;
                        suspend;
                    End
            END
     suspend;
   End

END^



CREATE PROCEDURE fc_branches_intermediaires
		(STRUCTURE_Clep varchar(20), CleParent integer, NIVEAU integer,INDICE integer)
AS
begin
END^

ALTER PROCEDURE fc_branches_intermediaires
		(STRUCTURE_Clep varchar(20), CleParent integer, NIVEAU integer,INDICE integer)
AS
DECLARE TREE_BRANCHES CURSOR FOR (SELECT  STRU_Clep,
    STLI__Parent,  
	STRU_Type,
	STRU_Selectionne, 
	STRU_Libelle,
	STRU_Position
FROM STRUCTURE LEFT OUTER JOIN STRUCTURE_LIEE ON (STLI__Enfant = STRU_Clep)
WHERE STRU_Clep = :STRUCTURE_Clep
AND STLI__Parent= :STRUCTURE_Clep
ORDER BY STRU_Position,STRU_Libelle);
DECLARE AKEY integer;
DECLARE Parent_Clep varchar (20);
DECLARE Enfant_Clep varchar (20);
DECLARE TypeBranche SMALLINT;
DECLARE Selection SMALLINT;
DECLARE Libelle VARCHAR ( 360 );
DECLARE PositionBranche INTEGER;
BEGIN
----------- Insertion des modes de rglement -------------
OPEN TREE_BRANCHES;
while (TRUE) do
Begin
  FETCH NEXT FROM TREE_BRANCHES INTO Parent_Clep,Enfant_Clep,TypeBranche,Selection,Libelle,PositionBranche;
  if (row_count = 0) then leave;
  AKEY=:NIVEAU*1000+:INDICE+GEN_ID(TEMP_TREE_POS,1);
  INSERT INTO TEMP_TREE (ARDE_Table,
  ARDE_Clep,	
  ARDE_Parent,
  ARDE_Table_parent, -- La cl parent de la table
  ARDE_Table_clep, -- La cl de la table
  ARDE_Type,
  ARDE_Selection,
  ARDE_Prix,
  ARDE_Prixfutur,
  ARDE_Libelle,
  ARDE_Libcom,
  ARDE_Position,
  ARDE__COMP)  VALUES ( 'STRUCTURE_LIEE',:AKEY,:CleParent,:Parent_Clep,:Parent_Clep,:TypeBranche,:Selection,0,0,:Libelle,NULL,:PositionBranche,NULL);
  EXECUTE PROCEDURE fc_branches_intermediaires ( :Enfant_Clep, :AKEY, :Niveau +1, :Indice );
  suspend;
  End
CLOSE TREE_BRANCHES;

END^


CREATE PROCEDURE fc_arbre_base_compose
		(BASE_COMPOSE varchar(20), composants SMALLINT)
AS
DECLARE CleTable varchar (20);
DECLARE CleTable2 varchar (20);
DECLARE Cle integer;
DECLARE CleParent integer;
DECLARE Niveau integer;
DECLARE indice integer;
DECLARE curseur1 CURSOR FOR (SELECT ARDE_Table_clep, ARDE_Clep FROM TEMP_TREE WHERE ARDE_Type=1 AND ARDE_Parent = :CleParent);
DECLARE curseur2 CURSOR FOR (SELECT ARDE_Table_clep, ARDE_Clep FROM TEMP_TREE WHERE ARDE_Type=3);
DECLARE curseur3 CURSOR FOR (SELECT SCOM__COMP,SCOM__STRU FROM STRUCTURE_COMPOSANT);
BEGIN
Niveau=1;
Indice=0;
--SET GENERATOR TEMP_TREE_POS TO 1;
----------- Insertion de l'BASE_COMPOSE -------------
CleParent=:NIVEAU*1000+:INDICE+GEN_ID(TEMP_TREE_POS,1);
Niveau=:NIVEAU+1;
INSERT INTO TEMP_TREE (ARDE_Table,
  ARDE_Clep,	
  ARDE_Parent,
  ARDE_Table_parent, -- La cl parent de la table
  ARDE_Table_clep, -- La cl de la table
  ARDE_Type,
  ARDE_Selection,
  ARDE_Prix,
  ARDE_Prixfutur,
  ARDE_Libelle,
  ARDE_Libcom,
  ARDE_Position,
  ARDE__COMP)  SELECT  'ARTC_STRU',
	:NIVEAU*1000+:INDICE+GEN_ID(TEMP_TREE_POS,1),
	:CleParent,
	:BASE_COMPOSE,
	STRU_Clep,
	STRU_Type,
	STRU_Selectionne, 
	NULL,
	NULL,
	STRU_Libelle,
	NULL,
	STRU_Position,
	NULL
	FROM STRUCTURE, BASE_COMPOSE_STRUCTURE 
	WHERE ARST__STRU = STRU_Clep 
	AND ARST__BACO= :BASE_COMPOSE
	ORDER BY STRU_Position,STRU_Libelle;

OPEN curseur1;

while (TRUE) do
  Begin
  FETCH NEXT FROM curseur1 INTO CleTable, Cle;
  if (row_count = 0) then leave;
  EXECUTE PROCEDURE fc_branches_base_compose ( :CleTable, :Cle, :niveau+1, :indice );
  suspend;
  End
CLOSE curseur1;

IF (:composants = 1) then
  BEGIN

	OPEN curseur2;

    while (TRUE) do
    Begin
        FETCH NEXT FROM curseur2 INTO CleTable, Cle;
        if (row_count = 0) then leave;
        EXECUTE PROCEDURE fc_composants_base_compose ( :CleTable, :Cle, :niveau+1, :indice );
        suspend;
    End
    CLOSE curseur2;
  END

IF (:composants = 2) then
  BEGIN
	OPEN curseur3;

    while (TRUE) do
    Begin
        FETCH NEXT FROM curseur3 INTO CleTable, CleTable2;
        if (row_count = 0) then leave;
        UPDATE TEMP_TREE
        SET ARDE__COMP = :CleTable
        WHERE ARDE_Table_clep = :CleTable2	
        AND ARDE_Type = 2;
        suspend;
    End
    CLOSE curseur3;
  END

EXECUTE procedure fc_base_compose_uniquement (:BASE_COMPOSE,:niveau+1,:indice);
END^

CREATE PROCEDURE fc_retrouve_base_compose (STRU_Clep varchar(20))
RETURNS
(ARDE_Clep varchar(20))
AS
begin
END^


ALTER PROCEDURE FC_RETROUVE_BASE_COMPOSE (
    STRU_CLEP varchar(20) )
RETURNS (
    ARDE_CLEP varchar(20) )
AS
DECLARE Cle varchar(20);
DECLARE curseur CURSOR FOR (SELECT
		STLI__Parent,STRU_Type
		FROM STRUCTURE_LIEE, STRUCTURE
		WHERE STLI__Parent=STRU_Clep
		AND STLI__Enfant = :Cle);
DECLARE TypeStru integer;
DECLARE ARDE_Temp varchar(20);
BEGIN
----------- Insertion des modes de rglement -------------


TypeStru = ( SELECT STRU_Type FROM STRUCTURE WHERE STRU_Clep = :STRU_Clep );

IF (:TypeStru = 1) then
	BEGIN
      begin
        ARDE_CLEP=:STRU_Clep;
      end
	END
ELSE
	BEGIN
    Cle=:STRU_Clep;
	OPEN curseur;

	while (TRUE) do
		Begin
		  FETCH NEXT FROM curseur INTO Cle,TypeStru;
          if (row_count = 0) then leave;
          if (:TypeStru=1) then
           begin
            ARDE_CLEP=:Cle;
           end  
		End

	CLOSE curseur;
	End
suspend;
END^
SET TERM ; ^

